Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jain.protocol.ss7.oam
Interface OamLayerManagerMBean

All Known Subinterfaces:
  Mtp2LayerManagerMBean, Mtp3LayerManagerMBean, SccpLayerManagerMBean, TcapLayerManagerMBean

public abstract interface OamLayerManagerMBean

This interface defines the methods common to all Protocol Layer Managers. It defines the methods to:

- Commit all operations on any OamManagedObjectMBeans in this layer.
- Get the current configuration of the SS7 Stack being managed. Invoking this method will create instances of Managed MBeans for each physical element in the system and create the necessary associations between them.
- Dynamically configure the Protocol Variant and Year supported by this Protocol Layer Manager (if allowed by the implementation).

When creating a MBean an entry must be added to the LookupTable of that MBean's ObjectName and reference, and when a MBean is being deleted the corresponding entry in the LookupTable must be removed. This is to enable the application to operate successfully without a JMX agent.

This illustrates how JAIN OAM MBeans are instantiated

Version:
  1.1
Author:
  Colm Hayden& Phelim O'Doherty

Field Summary
`static int` | `PROTOCOL_VARIANT_ANSI_1992` A Protocol Version constant: ANSI Protocol
`static int` | `PROTOCOL_VARIANT_ANSI_1996`
`static int` | `PROTOCOL_VARIANT_ITU_1993` A Protocol Version constant: ITU Protocol
`static int` | `PROTOCOL_VARIANT_ITU_1996`
`static int` | `PROTOCOL_VARIANT_ITU_1997`
`static int` | `PROTOCOL_VARIANT_OTHER` A Protocol Version constant: a protocol other then ITU or ANSI

Method Summary
`void` | `addNotificationListenerToAllMBeans(NotificationListener listener, NotificationFilter filter, java.lang.Object handback)` Registers the specified NotificationListener with all of the OamManagedObjectMBeans of this Layer Manager.
`void` | `commit()` Commit all operations on any Managed MBeans in this layer.
`ObjectName[]` | `getAllOamManagedObjects()` Returns an array containing the ObjectNames all of the OamManagedObjectMBeans managed by this Layer Manager.
`OamLookupTable` | `getLookupTable()` Returns a reference to the OamLookupTable.
`java.lang.Integer` | `getProtocolVariantAndYear()` Returns the Protocol variant and year.
`java.lang.String` | `getStackName()` Returns the Stack Name.
`java.lang.String` | `getVendorDetails()` Returns a String that identifies the Vendor that supplied this implementation.
`void` | `readCurrentConfiguration()` Gets the current configuration of the SS7 Layer being managed.
`void` | `removeNotificationListenerFromAllMBeans(NotificationListener listener)` Removes the specified NotificationListener from listening to all of the OamManagedObjectMBeans of this Layer Manager.
`void` | `rollBack()` Resets the MBeans back to the state they were in after the last call to the commit() or readCurrentConfiguration().
`void` | `setProtocolVariantAndYear(java.lang.Integer variantAndYear)` Sets the protocol variant and year of the SS7 Protocol Layer represented by this OamLayerManager.
`void` | `setStackName(java.lang.String stackName)` Sets the Name of this Stack.

Field Detail

### PROTOCOL_VARIANT_ANSI_1992

    public static final int PROTOCOL_VARIANT_ANSI_1992

  A Protocol Version constant: ANSI Protocol

### PROTOCOL_VARIANT_ANSI_1996

    public static final int PROTOCOL_VARIANT_ANSI_1996

### PROTOCOL_VARIANT_ITU_1993

    public static final int PROTOCOL_VARIANT_ITU_1993

  A Protocol Version constant: ITU Protocol

### PROTOCOL_VARIANT_ITU_1996

    public static final int PROTOCOL_VARIANT_ITU_1996

### PROTOCOL_VARIANT_ITU_1997

    public static final int PROTOCOL_VARIANT_ITU_1997

### PROTOCOL_VARIANT_OTHER

    public static final int PROTOCOL_VARIANT_OTHER

  A Protocol Version constant: a protocol other then ITU or ANSI

Method Detail

### addNotificationListenerToAllMBeans

    public void addNotificationListenerToAllMBeans(NotificationListener listener,
                                                   NotificationFilter filter,
                                                   java.lang.Object handback)
                                            throws java.lang.NullPointerException

  Registers the specified NotificationListener with all of the OamManagedObjectMBeans of this Layer Manager. The specified listener will be registered as a NotificationListener with all of the OamManagedObjectMBeans of this Layer Manager using the specified handback and filter for all registrations. Should an MBean be created after this method is called, the listener will not automatically be added to the newly created MBean and this method or addNotificationListener must be called again.
  Parameters:
    `listener` - the NotificationListener to be registered with all of the MBeans of this Layer Manager. ie - all OamManagedObjects returned by getAllOamManagedObjects()
    `filter` - The filter object. If not specified, no filtering will be performed before handling notifications.
    `handback` - The context to be sent to the listener when a notification is emitted.
  Throws:
    java.lang.NullPointerException - if the supplied listener is null

### removeNotificationListenerFromAllMBeans

    public void removeNotificationListenerFromAllMBeans(NotificationListener listener)
                                                 throws java.lang.NullPointerException

  Removes the specified NotificationListener from listening to all of the OamManagedObjectMBeans of this Layer Manager. This will have the same effect as calling the removeNotificationListener() method on all OamManagedObjectMBeans returned by getAllOamManagedObjects()
  Parameters:
    `listener` - the NotificationListener to be removed
  Throws:
    java.lang.NullPointerException - if the supplied Listener is null

### getAllOamManagedObjects

    public ObjectName[] getAllOamManagedObjects()

  Returns an array containing the ObjectNames all of the OamManagedObjectMBeans managed by this Layer Manager. E.g. For an Mtp3LayerManagerMbean the returned array will contain the ObjectNames of all of the Mtp3ManagedObjectMBeans that were either:

  - explicitly created through the create() methods defined on the Mtp3LayerManager, or
  - implicitly created through the readCurrentConfiguration() method

### rollBack

    public void rollBack()

  Resets the MBeans back to the state they were in after the last call to the commit() or readCurrentConfiguration(). Or in the case of neither of these methods being called then the MBeans are reset to this original state.

### commit

    public void commit()
                throws CommitException

  Commit all operations on any Managed MBeans in this layer. The implementation of this method shall commit all operations to the underlying proprietary management system.

  Successfully invoking the 'commit()' command shall have three separate consequences:

  1. When an application requests the creation of a MBean from this Layer Maneger, the Layer Manager should create an instance of the appropriate MBean. Only when this commit() method has been invoked should the corresponding element be committed to the underlying proprietary management system.
  2. When an attribute `xxxx` of an MBean is modified using `setXxxx()`, the new attribute value will only be returned from `getXxxx()` and the changes will only be propagated to the underlying proprietary management system when this commit() method has been invoked.
  3. When an application requests the deletion of a MBean from a Layer Manager, that MBean should be tagged 'for deletion', but the corresponding element should not be deleted from the underlying proprietary management system until this commit() method has been invoked.
  Throws:
    CommitException - - if any of the operations to be committed were not committed successfully. This CommitException shall list the operations that were to be committed and will indicate whether or not each operation was successfully committed.

### readCurrentConfiguration

    public void readCurrentConfiguration()
                                  throws ReadConfigurationException

  Gets the current configuration of the SS7 Layer being managed. Invoking this method will create instances of Managed MBeans for each physical element in the system and create the necessary associations between them
  Throws:
    ReadConfigurationException - - if an error is encountered while attempting to establish the current system configuration or while creating the Managed MBeans that represent the current system configuration.

### getVendorDetails

    public java.lang.String getVendorDetails()

  Returns a String that identifies the Vendor that supplied this implementation.
  Returns:
    a string identifying the Vendor implementation

### setProtocolVariantAndYear

    public void setProtocolVariantAndYear(java.lang.Integer variantAndYear)
                                   throws java.lang.UnsupportedOperationException,
                                          java.lang.IllegalArgumentException

  Sets the protocol variant and year of the SS7 Protocol Layer represented by this OamLayerManager. If the underlying SS7 Stack has the the capability of being configured dynamically as to what variant and year of the protocol is it supporting then this method will dynamically configure the stack.
  Parameters:
    `variantAndYear` - the Protocol Variant and Year that this Protocol Layer shall be configured to.
    Can be one of the following:

    - PROTOCOL_VARIANT_ANSI_1993
    - PROTOCOL_VARIANT_ANSI_1997
    - PROTOCOL_VARIANT_ITU_1992
    - PROTOCOL_VARIANT_ITU_1996
    - PROTOCOL_VARIANT_OTHER
  Throws:
    java.lang.UnsupportedOperationException - if the implementation does not support the configuration of the protocol variant and year (i.e. Protocol variant and year are read-only values).
    java.lang.IllegalArgumentException - - if the suplied protocol variant and year are in an incorrect format

### getProtocolVariantAndYear

    public java.lang.Integer getProtocolVariantAndYear()

  Returns the Protocol variant and year.
  Returns:
    one of the following:

    - PROTOCOL_VARIANT_ANSI_1993
    - PROTOCOL_VARIANT_ANSI_1997
    - PROTOCOL_VARIANT_ITU_1992
    - PROTOCOL_VARIANT_ITU_1996
    - PROTOCOL_VARIANT_OTHER

### setStackName

    public void setStackName(java.lang.String stackName)

  Sets the Name of this Stack. Could be any proprietary format. Setting the stack name allows the implemention to distinguish between different virtual stacks. The layer managers can be combined into one virtual stack by setting the same stack name for each layer.

### getStackName

    public java.lang.String getStackName()

  Returns the Stack Name.
  Returns:
    the stack name that was set by the setStackName method.

### getLookupTable

    public OamLookupTable getLookupTable()

  Returns a reference to the OamLookupTable.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

11 August 2000

Copyright - 2000 Sun Microsystems